Index: /trunk/src/sys/arch/mips/mips/fp.S
===================================================================
--- /trunk/src/sys/arch/mips/mips/fp.S	(revision 151)
+++ /trunk/src/sys/arch/mips/mips/fp.S	(revision 152)
@@ -4553,780 +4549,9 @@
 END(renorm_ft_d)
 
-#ifdef FPEMUL
-/*
- * Emulate branch delay slot CPU instruction.
- * Enter from BC1x emulation.
- * These instructions are not implemented and causes SIGILL.
- *  jump/branch
- *  COP0
- *  64bit operation
- *  trap/syscall/break
- *
- * Args are same as MachEmulateFP.
- * It should be used to emulate instruction in branch delay slot.
- */
-STATIC_LEAF(bcemul_delay_slot)
-	REG_PROLOGUE
-	REG_S	zero, TF_REG_ZERO(a1)		# ensure zero has value 0
-	REG_EPILOGUE
-
-	srl	t0, a0, 26-PTR_SCALESHIFT
-	andi	t0, t0, 0x3F << PTR_SCALESHIFT
-	PTR_L	t0, bcemul_optbl(t0)
-	j	t0
-
-bcemul_special:
-	sll	t0, a0, PTR_SCALESHIFT
-	andi	t0, t0, 0x3F << PTR_SCALESHIFT
-	PTR_L	t0, bcemul_specialtbl(t0)
-	j	t0
-
-	.rdata
-bcemul_optbl:
-	PTR_WORD bcemul_special			# 0
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 1
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 2
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 3
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 4
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 5
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 6
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 7
-	PTR_WORD bcemul_addi			# 8
-	PTR_WORD bcemul_addiu			# 9
-	PTR_WORD bcemul_slti			# 10
-	PTR_WORD bcemul_sltiu			# 11
-	PTR_WORD bcemul_andi			# 12
-	PTR_WORD bcemul_ori			# 13
-	PTR_WORD bcemul_xori			# 14
-	PTR_WORD bcemul_lui			# 15
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 16
-	PTR_WORD _C_LABEL(MachEmulateFP)	# 17
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 18
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 19 /* COP1X */
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 20
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 21
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 22
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 23
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 24 DADDI
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 25 DADDIU
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 26
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 27
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 28
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 29
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 30
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 31
-	PTR_WORD _C_LABEL(bcemul_lb)		# 32
-	PTR_WORD _C_LABEL(bcemul_lh)		# 33
-	PTR_WORD _C_LABEL(bcemul_lwl)		# 34
-	PTR_WORD _C_LABEL(bcemul_lw)		# 35
-	PTR_WORD _C_LABEL(bcemul_lbu)		# 36
-	PTR_WORD _C_LABEL(bcemul_lhu)		# 37
-	PTR_WORD _C_LABEL(bcemul_lwr)		# 38
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 39
-	PTR_WORD _C_LABEL(bcemul_sb)		# 40
-	PTR_WORD _C_LABEL(bcemul_sh)		# 41
-	PTR_WORD _C_LABEL(bcemul_swl)		# 42
-	PTR_WORD _C_LABEL(bcemul_sw)		# 43
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 44
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 45
-	PTR_WORD _C_LABEL(bcemul_swr)		# 46 SWR
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 47
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 48
-	PTR_WORD _C_LABEL(MachEmulateLWC1)	# 49
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 50
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 51
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 52
-	PTR_WORD _C_LABEL(MachEmulateLDC1)	# 53
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 54
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 55 LD
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 56
-	PTR_WORD _C_LABEL(MachEmulateSWC1)	# 57
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 58
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 59
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 60
-	PTR_WORD _C_LABEL(MachEmulateSDC1)	# 61
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 62
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 63 SD
-
-bcemul_specialtbl:
-	PTR_WORD bcemul_sll		# 0
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 1
-	PTR_WORD bcemul_srl		# 2
-	PTR_WORD bcemul_sra		# 3
-	PTR_WORD bcemul_sllv		# 4
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 5
-	PTR_WORD bcemul_srlv		# 6
-	PTR_WORD bcemul_srav		# 7
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 8
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 9
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 10
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 11
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 12
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 13
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 14
-	PTR_WORD bcemul_sync		# 15
-	PTR_WORD bcemul_mfhi		# 16
-	PTR_WORD bcemul_mthi		# 17
-	PTR_WORD bcemul_mflo		# 18
-	PTR_WORD bcemul_mtlo		# 19
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 20
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 21
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 22
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 23
-	PTR_WORD bcemul_mult		# 24
-	PTR_WORD bcemul_multu		# 25
-	PTR_WORD bcemul_div		# 26
-	PTR_WORD bcemul_divu		# 27
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 28
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 29
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 30
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 31
-	PTR_WORD bcemul_add		# 32
-	PTR_WORD bcemul_addu		# 33
-	PTR_WORD bcemul_sub		# 34
-	PTR_WORD bcemul_subu		# 35
-	PTR_WORD bcemul_and		# 36
-	PTR_WORD bcemul_or		# 37
-	PTR_WORD bcemul_xor		# 38
-	PTR_WORD bcemul_nor		# 39
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 40
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 41
-	PTR_WORD bcemul_slt		# 42
-	PTR_WORD bcemul_sltu		# 43
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 44
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 45
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 46
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 47
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 48
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 49
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 50
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 51
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 52
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 53
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 54
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 55
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 56
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 57
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 58
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 59
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 60
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 61
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 62
-	PTR_WORD _C_LABEL(bcemul_sigill)	# 63
-
-	.text
-
-bcemul_addi:
-	srl	t0, a0, 21-REG_SCALESHIFT	# rs
-	srl	t1, a0, 16-REG_SCALESHIFT	# rt
-	andi	t0, t0, REG_REGMASK
-	andi	t1, t1, REG_REGMASK
-	PTR_ADDU t0, a1, t0
-	PTR_ADDU t1, a1, t1
-	sll	t2, a0, 16
-	sra	t2, t2, 16
-	REG_PROLOGUE
-	REG_L	v0, TF_REG_ZERO(t0)
-	REG_EPILOGUE
-	addu	t0, v0, t2
-
-	/* Overflow check */
-	xor	t2, v0, t2
-	srl	t2, t2, 31
-	bne	t2, zero, addiok
-
-	xor	v0, v0, t0
-	srl	v0, v0, 31
-	beq	v0, zero, addiok
-
-	j	_C_LABEL(bcemul_sigfpe)
-
-addiok:
-	REG_PROLOGUE
-	REG_S	t0, TF_REG_ZERO(t1)
-	REG_EPILOGUE
-	b	bcemul_done
-
-bcemul_addiu:
-	srl	t0, a0, 21-REG_SCALESHIFT	# rs
-	srl	t1, a0, 16-REG_SCALESHIFT	# rt
-	andi	t0, t0, REG_REGMASK
-	andi	t1, t1, REG_REGMASK
-	PTR_ADDU t0, a1, t0
-	PTR_ADDU t1, a1, t1
-	sll	t2, a0, 16
-	sra	t2, t2, 16
-	REG_PROLOGUE
-	REG_L	v0, TF_REG_ZERO(t0)
-	addu	v0, v0, t2
-	REG_S	v0, TF_REG_ZERO(t1)
-	REG_EPILOGUE
-	b	bcemul_done
-
-bcemul_slti:
-	srl	t0, a0, 21-REG_SCALESHIFT	# rs
-	srl	t1, a0, 16-REG_SCALESHIFT	# rt
-	andi	t0, t0, REG_REGMASK
-	andi	t1, t1, REG_REGMASK
-	PTR_ADDU t0, a1, t0
-	PTR_ADDU t1, a1, t1
-	sll	t2, a0, 16
-	sra	t2, t2, 16
-	REG_PROLOGUE
-	REG_L	v0, TF_REG_ZERO(t0)
-	slt	v0, v0, t2
-	REG_S	v0, TF_REG_ZERO(t1)
-	REG_EPILOGUE
-	b	bcemul_done
-
-bcemul_sltiu:
-	srl	t0, a0, 21-REG_SCALESHIFT	# rs
-	srl	t1, a0, 16-REG_SCALESHIFT	# rt
-	andi	t0, t0, REG_REGMASK
-	andi	t1, t1, REG_REGMASK
-	PTR_ADDU t0, a1, t0
-	PTR_ADDU t1, a1, t1
-	sll	t2, a0, 16
-	sra	t2, t2, 16
-	REG_PROLOGUE
-	REG_L	v0, TF_REG_ZERO(t0)
-	sltu	v0, v0, t2
-	REG_S	v0, TF_REG_ZERO(t1)
-	REG_EPILOGUE
-	b	bcemul_done
-
-bcemul_andi:
-	srl	t0, a0, 21-REG_SCALESHIFT	# rs
-	srl	t1, a0, 16-REG_SCALESHIFT	# rt
-	andi	t0, t0, REG_REGMASK
-	andi	t1, t1, REG_REGMASK
-	PTR_ADDU t0, a1, t0
-	PTR_ADDU t1, a1, t1
-	andi	t2, a0, 0xFFFF
-	REG_PROLOGUE
-	REG_L	v0, TF_REG_ZERO(t0)
-	and	v0, v0, t2
-	REG_S	v0, TF_REG_ZERO(t1)
-	REG_EPILOGUE
-	b	bcemul_done
-
-bcemul_ori:
-	srl	t0, a0, 21-REG_SCALESHIFT	# rs
-	srl	t1, a0, 16-REG_SCALESHIFT	# rt
-	andi	t0, t0, REG_REGMASK
-	andi	t1, t1, REG_REGMASK
-	PTR_ADDU t0, a1, t0
-	PTR_ADDU t1, a1, t1
-	andi	t2, a0, 0xFFFF
-	REG_PROLOGUE
-	REG_L	v0, TF_REG_ZERO(t0)
-	or	v0, v0, t2
-	REG_S	v0, TF_REG_ZERO(t1)
-	REG_EPILOGUE
-	b	bcemul_done
-
-bcemul_xori:
-	srl	t0, a0, 21-REG_SCALESHIFT	# rs
-	srl	t1, a0, 16-REG_SCALESHIFT	# rt
-	andi	t0, t0, REG_REGMASK
-	andi	t1, t1, REG_REGMASK
-	PTR_ADDU t0, a1, t0
-	PTR_ADDU t1, a1, t1
-	andi	t2, a0, 0xFFFF
-	REG_PROLOGUE
-	REG_L	v0, TF_REG_ZERO(t0)
-	xor	v0, v0, t2
-	REG_S	v0, TF_REG_ZERO(t1)
-	REG_EPILOGUE
-	b	bcemul_done
-
-bcemul_lui:
-	srl	t0, a0, 16-REG_SCALESHIFT	# rt
-	andi	t0, t0, REG_REGMASK
-	PTR_ADDU t0, a1, t0
-	sll	v0, a0, 16
-	REG_PROLOGUE
-	REG_S	v0, TF_REG_ZERO(t0)
-	REG_EPILOGUE
-	b	bcemul_done
-
-bcemul_sll:
-	srl	t0, a0, 16-REG_SCALESHIFT	# rt
-	srl	t1, a0, 11-REG_SCALESHIFT	# rd
-	srl	t2, a0, 6		# sa
-	andi	t0, t0, REG_REGMASK
-	andi	t1, t1, REG_REGMASK
-	andi	t2, t2, 0x001F
-	PTR_ADDU t0, a1, t0
-	PTR_ADDU t1, a1, t1
-	REG_PROLOGUE
-	REG_L	v0, TF_REG_ZERO(t0)
-	sllv	v0, v0, t2
-	REG_S	v0, TF_REG_ZERO(t1)
-	REG_EPILOGUE
-	b	bcemul_done
-
-bcemul_srl:
-	srl	t0, a0, 16-REG_SCALESHIFT	# rt
-	srl	t1, a0, 11-REG_SCALESHIFT	# rd
-	srl	t2, a0, 6		# sa
-	andi	t0, t0, REG_REGMASK
-	andi	t1, t1, REG_REGMASK
-	andi	t2, t2, 0x001F
-	PTR_ADDU t0, a1, t0
-	PTR_ADDU t1, a1, t1
-	REG_PROLOGUE
-	REG_L	v0, TF_REG_ZERO(t0)
-	srlv	v0, v0, t2
-	REG_S	v0, TF_REG_ZERO(t1)
-	REG_EPILOGUE
-	b	bcemul_done
-
-bcemul_sra:
-	srl	t0, a0, 16-REG_SCALESHIFT	# rt
-	srl	t1, a0, 11-REG_SCALESHIFT	# rd
-	srl	t2, a0, 6		# sa
-	andi	t0, t0, REG_REGMASK
-	andi	t1, t1, REG_REGMASK
-	andi	t2, t2, 0x001F
-	PTR_ADDU t0, a1, t0
-	PTR_ADDU t1, a1, t1
-	REG_PROLOGUE
-	REG_L	v0, TF_REG_ZERO(t0)
-	srav	v0, v0, t2
-	REG_S	v0, TF_REG_ZERO(t1)
-	REG_EPILOGUE
-	b	bcemul_done
-
-bcemul_sllv:
-	srl	t0, a0, 21-REG_SCALESHIFT	# rs
-	srl	t1, a0, 16-REG_SCALESHIFT	# rt
-	srl	t2, a0, 11-REG_SCALESHIFT	# rd
-	andi	t0, t0, REG_REGMASK
-	andi	t1, t1, REG_REGMASK
-	andi	t2, t2, REG_REGMASK
-	PTR_ADDU t0, a1, t0
-	PTR_ADDU t1, a1, t1
-	PTR_ADDU t2, a1, t2
-	REG_PROLOGUE
-	REG_L	v0, TF_REG_ZERO(t0)
-	REG_L	v1, TF_REG_ZERO(t1)
-	sllv	v0, v1, v0
-	REG_S	v0, TF_REG_ZERO(t2)
-	REG_EPILOGUE
-	b	bcemul_done
-
-bcemul_srlv:
-	srl	t0, a0, 21-REG_SCALESHIFT	# rs
-	srl	t1, a0, 16-REG_SCALESHIFT	# rt
-	srl	t2, a0, 11-REG_SCALESHIFT	# rd
-	andi	t0, t0, REG_REGMASK
-	andi	t1, t1, REG_REGMASK
-	andi	t2, t2, REG_REGMASK
-	PTR_ADDU t0, a1, t0
-	PTR_ADDU t1, a1, t1
-	PTR_ADDU t2, a1, t2
-	REG_PROLOGUE
-	REG_L	v0, TF_REG_ZERO(t0)
-	REG_L	v1, TF_REG_ZERO(t1)
-	srlv	v0, v1, v0
-	REG_S	v0, TF_REG_ZERO(t2)
-	REG_EPILOGUE
-	b	bcemul_done
-
-bcemul_srav:
-	srl	t0, a0, 21-REG_SCALESHIFT	# rs
-	srl	t1, a0, 16-REG_SCALESHIFT	# rt
-	srl	t2, a0, 11-REG_SCALESHIFT	# rd
-	andi	t0, t0, REG_REGMASK
-	andi	t1, t1, REG_REGMASK
-	andi	t2, t2, REG_REGMASK
-	PTR_ADDU t0, a1, t0
-	PTR_ADDU t1, a1, t1
-	PTR_ADDU t2, a1, t2
-	REG_PROLOGUE
-	REG_L	v0, TF_REG_ZERO(t0)
-	REG_L	v1, TF_REG_ZERO(t1)
-	srav	v0, v1, v0
-	REG_S	v0, TF_REG_ZERO(t2)
-	REG_EPILOGUE
-	b	bcemul_done
-
-bcemul_sync:
-	b	bcemul_done
-
-bcemul_mfhi:
-	srl	t0, a0, 11-REG_SCALESHIFT	# rd
-	andi	t0, t0, REG_REGMASK
-	PTR_ADDU t0, a1, t0
-	REG_PROLOGUE
-	REG_L	v0, TF_REG_MULHI(a1)
-	REG_S	v0, TF_REG_ZERO(t0)
-	REG_EPILOGUE
-	b	bcemul_done
-
-bcemul_mthi:
-	srl	t0, a0, 21-REG_SCALESHIFT	# rs
-	andi	t0, t0, REG_REGMASK
-	PTR_ADDU t0, a1, t0
-	REG_PROLOGUE
-	REG_L	v0, TF_REG_ZERO(t0)
-	REG_S	v0, TF_REG_MULHI(a1)
-	REG_EPILOGUE
-	b	bcemul_done
-
-bcemul_mflo:
-	srl	t0, a0, 11-REG_SCALESHIFT	# rd
-	andi	t0, t0, REG_REGMASK
-	PTR_ADDU t0, a1, t0
-	REG_PROLOGUE
-	REG_L	v0, TF_REG_MULLO(a1)
-	REG_S	v0, TF_REG_ZERO(t0)
-	REG_EPILOGUE
-	b	bcemul_done
-
-bcemul_mtlo:
-	srl	t0, a0, 21-REG_SCALESHIFT	# rs
-	andi	t0, t0, REG_REGMASK
-	PTR_ADDU t0, a1, t0
-	REG_PROLOGUE
-	REG_L	v0, TF_REG_ZERO(t0)
-	REG_S	v0, TF_REG_MULLO(a1)
-	REG_EPILOGUE
-	b	bcemul_done
-
-bcemul_mult:
-	srl	t0, a0, 21-REG_SCALESHIFT	# rs
-	srl	t1, a0, 16-REG_SCALESHIFT	# rt
-	andi	t0, t0, REG_REGMASK
-	andi	t1, t1, REG_REGMASK
-	PTR_ADDU t0, a1, t0
-	PTR_ADDU t1, a1, t1
-	REG_PROLOGUE
-	REG_L	v0, TF_REG_ZERO(t0)
-	REG_L	v1, TF_REG_ZERO(t1)
-	REG_EPILOGUE
-	mult	v0, v1
-	mflo	v0
-	mfhi	v1
-	REG_PROLOGUE
-	REG_S	v0, TF_REG_MULLO(a1)
-	REG_S	v1, TF_REG_MULHI(a1)
-	REG_EPILOGUE
-	b	bcemul_done
-
-bcemul_multu:
-	srl	t0, a0, 21-REG_SCALESHIFT	# rs
-	srl	t1, a0, 16-REG_SCALESHIFT	# rt
-	andi	t0, t0, REG_REGMASK
-	andi	t1, t1, REG_REGMASK
-	PTR_ADDU t0, a1, t0
-	PTR_ADDU t1, a1, t1
-	REG_PROLOGUE
-	REG_L	v0, TF_REG_ZERO(t0)
-	REG_L	v1, TF_REG_ZERO(t1)
-	REG_EPILOGUE
-	multu	v0, v1
-	mflo	v0
-	mfhi	v1
-	REG_PROLOGUE
-	REG_S	v0, TF_REG_MULLO(a1)
-	REG_S	v1, TF_REG_MULHI(a1)
-	REG_EPILOGUE
-	b	bcemul_done
-
-bcemul_div:
-	srl	t0, a0, 21-REG_SCALESHIFT	# rs
-	srl	t1, a0, 16-REG_SCALESHIFT	# rt
-	andi	t0, t0, REG_REGMASK
-	andi	t1, t1, REG_REGMASK
-	PTR_ADDU t0, a1, t0
-	PTR_ADDU t1, a1, t1
-	REG_PROLOGUE
-	REG_L	v0, TF_REG_ZERO(t0)
-	REG_L	v1, TF_REG_ZERO(t1)
-	REG_EPILOGUE
-	div	v0, v1
-	mflo	v0
-	mfhi	v1
-	REG_PROLOGUE
-	REG_S	v0, TF_REG_MULLO(a1)
-	REG_S	v1, TF_REG_MULHI(a1)
-	REG_EPILOGUE
-	b	bcemul_done
-
-bcemul_divu:
-	srl	t0, a0, 21-REG_SCALESHIFT	# rs
-	srl	t1, a0, 16-REG_SCALESHIFT	# rt
-	andi	t0, t0, REG_REGMASK
-	andi	t1, t1, REG_REGMASK
-	PTR_ADDU t0, a1, t0
-	PTR_ADDU t1, a1, t1
-	REG_PROLOGUE
-	REG_L	v0, TF_REG_ZERO(t0)
-	REG_L	v1, TF_REG_ZERO(t1)
-	REG_EPILOGUE
-	divu	v0, v1
-	mflo	v0
-	mfhi	v1
-	REG_PROLOGUE
-	REG_S	v0, TF_REG_MULLO(a1)
-	REG_S	v1, TF_REG_MULHI(a1)
-	REG_EPILOGUE
-	b	bcemul_done
-
-bcemul_add:
-	srl	t0, a0, 21-REG_SCALESHIFT	# rs
-	srl	t1, a0, 16-REG_SCALESHIFT	# rt
-	srl	t2, a0, 11-REG_SCALESHIFT	# rd
-	andi	t0, t0, REG_REGMASK
-	andi	t1, t1, REG_REGMASK
-	andi	t2, t2, REG_REGMASK
-	PTR_ADDU t0, a1, t0
-	PTR_ADDU t1, a1, t1
-	PTR_ADDU t2, a1, t2
-	REG_PROLOGUE
-	REG_L	v0, TF_REG_ZERO(t0)
-	REG_L	v1, TF_REG_ZERO(t1)
-	REG_EPILOGUE
-	addu	t0, v0, v1
-
-	/* Overflow check */
-	xor	v1, v0, v1
-	srl	v1, v1, 31
-	bne	v1, zero, addok
-
-	xor	v0, v0, t0
-	srl	v0, v0, 31
-	beq	v0, zero, addok
-
-	j	_C_LABEL(bcemul_sigfpe)
-
-addok:
-	REG_PROLOGUE
-	REG_S	t0, TF_REG_ZERO(t2)
-	REG_EPILOGUE
-	b	bcemul_done
-
-bcemul_addu:
-	srl	t0, a0, 21-REG_SCALESHIFT	# rs
-	srl	t1, a0, 16-REG_SCALESHIFT	# rt
-	srl	t2, a0, 11-REG_SCALESHIFT	# rd
-	andi	t0, t0, REG_REGMASK
-	andi	t1, t1, REG_REGMASK
-	andi	t2, t2, REG_REGMASK
-	PTR_ADDU t0, a1, t0
-	PTR_ADDU t1, a1, t1
-	PTR_ADDU t2, a1, t2
-	REG_PROLOGUE
-	REG_L	v0, TF_REG_ZERO(t0)
-	REG_L	v1, TF_REG_ZERO(t1)
-	addu	v0, v0, v1
-	REG_S	v0, TF_REG_ZERO(t2)
-	REG_EPILOGUE
-	b	bcemul_done
-
-bcemul_sub:
-	srl	t0, a0, 21-REG_SCALESHIFT	# rs
-	srl	t1, a0, 16-REG_SCALESHIFT	# rt
-	srl	t2, a0, 11-REG_SCALESHIFT	# rd
-	andi	t0, t0, REG_REGMASK
-	andi	t1, t1, REG_REGMASK
-	andi	t2, t2, REG_REGMASK
-	PTR_ADDU t0, a1, t0
-	PTR_ADDU t1, a1, t1
-	PTR_ADDU t2, a1, t2
-	REG_PROLOGUE
-	REG_L	v0, TF_REG_ZERO(t0)
-	REG_L	v1, TF_REG_ZERO(t1)
-	REG_EPILOGUE
-	subu	t0, v0, v1
-
-	/* Overflow check */
-	xor	v1, v0, v1
-	srl	v1, v1, 31
-	beq	v1, zero, subok
-
-	xor	v0, v0, t0
-	srl	v0, v0, 31
-	beq	v0, zero, subok
-
-	j	_C_LABEL(bcemul_sigfpe)
-
-subok:
-	REG_PROLOGUE
-	REG_S	t0, TF_REG_ZERO(t2)
-	REG_EPILOGUE
-	b	bcemul_done
-
-bcemul_subu:
-	srl	t0, a0, 21-REG_SCALESHIFT	# rs
-	srl	t1, a0, 16-REG_SCALESHIFT	# rt
-	srl	t2, a0, 11-REG_SCALESHIFT	# rd
-	andi	t0, t0, REG_REGMASK
-	andi	t1, t1, REG_REGMASK
-	andi	t2, t2, REG_REGMASK
-	PTR_ADDU t0, a1, t0
-	PTR_ADDU t1, a1, t1
-	PTR_ADDU t2, a1, t2
-	REG_PROLOGUE
-	REG_L	v0, TF_REG_ZERO(t0)
-	REG_L	v1, TF_REG_ZERO(t1)
-	subu	v0, v0, v1
-	REG_S	v0, TF_REG_ZERO(t2)
-	REG_EPILOGUE
-	b	bcemul_done
-
-bcemul_and:
-	srl	t0, a0, 21-REG_SCALESHIFT	# rs
-	srl	t1, a0, 16-REG_SCALESHIFT	# rt
-	srl	t2, a0, 11-REG_SCALESHIFT	# rd
-	andi	t0, t0, REG_REGMASK
-	andi	t1, t1, REG_REGMASK
-	andi	t2, t2, REG_REGMASK
-	PTR_ADDU t0, a1, t0
-	PTR_ADDU t1, a1, t1
-	PTR_ADDU t2, a1, t2
-	REG_PROLOGUE
-	REG_L	v0, TF_REG_ZERO(t0)
-	REG_L	v1, TF_REG_ZERO(t1)
-	and	v0, v0, v1
-	REG_S	v0, TF_REG_ZERO(t2)
-	REG_EPILOGUE
-	b	bcemul_done
-
-bcemul_or:
-	srl	t0, a0, 21-REG_SCALESHIFT	# rs
-	srl	t1, a0, 16-REG_SCALESHIFT	# rt
-	srl	t2, a0, 11-REG_SCALESHIFT	# rd
-	andi	t0, t0, REG_REGMASK
-	andi	t1, t1, REG_REGMASK
-	andi	t2, t2, REG_REGMASK
-	PTR_ADDU t0, a1, t0
-	PTR_ADDU t1, a1, t1
-	PTR_ADDU t2, a1, t2
-	REG_PROLOGUE
-	REG_L	v0, TF_REG_ZERO(t0)
-	REG_L	v1, TF_REG_ZERO(t1)
-	or	v0, v0, v1
-	REG_S	v0, TF_REG_ZERO(t2)
-	REG_EPILOGUE
-	b	bcemul_done
-
-bcemul_xor:
-	srl	t0, a0, 21-REG_SCALESHIFT	# rs
-	srl	t1, a0, 16-REG_SCALESHIFT	# rt
-	srl	t2, a0, 11-REG_SCALESHIFT	# rd
-	andi	t0, t0, REG_REGMASK
-	andi	t1, t1, REG_REGMASK
-	andi	t2, t2, REG_REGMASK
-	PTR_ADDU t0, a1, t0
-	PTR_ADDU t1, a1, t1
-	PTR_ADDU t2, a1, t2
-	REG_PROLOGUE
-	REG_L	v0, TF_REG_ZERO(t0)
-	REG_L	v1, TF_REG_ZERO(t1)
-	xor	v0, v0, v1
-	REG_S	v0, TF_REG_ZERO(t2)
-	REG_EPILOGUE
-	b	bcemul_done
-
-bcemul_nor:
-	srl	t0, a0, 21-REG_SCALESHIFT	# rs
-	srl	t1, a0, 16-REG_SCALESHIFT	# rt
-	srl	t2, a0, 11-REG_SCALESHIFT	# rd
-	andi	t0, t0, REG_REGMASK
-	andi	t1, t1, REG_REGMASK
-	andi	t2, t2, REG_REGMASK
-	PTR_ADDU t0, a1, t0
-	PTR_ADDU t1, a1, t1
-	PTR_ADDU t2, a1, t2
-	REG_PROLOGUE
-	REG_L	v0, TF_REG_ZERO(t0)
-	REG_L	v1, TF_REG_ZERO(t1)
-	nor	v0, v0, v1
-	REG_S	v0, TF_REG_ZERO(t2)
-	REG_EPILOGUE
-	b	bcemul_done
-
-bcemul_slt:
-	srl	t0, a0, 21-REG_SCALESHIFT	# rs
-	srl	t1, a0, 16-REG_SCALESHIFT	# rt
-	srl	t2, a0, 11-REG_SCALESHIFT	# rd
-	andi	t0, t0, REG_REGMASK
-	andi	t1, t1, REG_REGMASK
-	andi	t2, t2, REG_REGMASK
-	PTR_ADDU t0, a1, t0
-	PTR_ADDU t1, a1, t1
-	PTR_ADDU t2, a1, t2
-	REG_PROLOGUE
-	REG_L	v0, TF_REG_ZERO(t0)
-	REG_L	v1, TF_REG_ZERO(t1)
-	slt	v0, v0, v1
-	REG_S	v0, TF_REG_ZERO(t2)
-	REG_EPILOGUE
-	b	bcemul_done
-
-bcemul_sltu:
-	srl	t0, a0, 21-REG_SCALESHIFT	# rs
-	srl	t1, a0, 16-REG_SCALESHIFT	# rt
-	srl	t2, a0, 11-REG_SCALESHIFT	# rd
-	andi	t0, t0, REG_REGMASK
-	andi	t1, t1, REG_REGMASK
-	andi	t2, t2, REG_REGMASK
-	PTR_ADDU t0, a1, t0
-	PTR_ADDU t1, a1, t1
-	PTR_ADDU t2, a1, t2
-	REG_PROLOGUE
-	REG_L	v0, TF_REG_ZERO(t0)
-	REG_L	v1, TF_REG_ZERO(t1)
-	sltu	v0, v0, v1
-	REG_S	v0, TF_REG_ZERO(t2)
-	REG_EPILOGUE
-#	b	bcemul_done		# fall through to bcemul_done
-
-bcemul_done:
-/*
- * Succeeded to emulate instruction with no error
- * so compute the next PC.
- */
-	PTR_SUBU sp, CALLFRAME_SIZ
-	REG_S	ra, CALLFRAME_RA(sp)
-	REG_S	a1, CALLFRAME_FRAME(sp)
-
-	/* Fetch previous branch instruction */
-	REG_PROLOGUE
-	REG_L	a0, TF_REG_EPC(a1)
-	REG_EPILOGUE
-	jal	_C_LABEL(fuiword)
-
-	REG_L	a1, CALLFRAME_FRAME(sp)
-
-	/* Calculate branch destination */
-	sll	t0, v0, 16
-	sra	t0, t0, 16-2
-	REG_PROLOGUE
-	REG_L	t1, TF_REG_EPC(a1)
-	PTR_ADDU t0, t0, 4
-	PTR_ADDU t1, t0
-	REG_S	t1, TF_REG_EPC(a1)
-	REG_EPILOGUE
-
-	REG_L	ra, CALLFRAME_RA(sp)
-	PTR_ADDU sp, CALLFRAME_SIZ
-	j	ra
-
-END(bcemul_delay_slot)
-
-#endif
-
 /*
  * Send SIGILL, SIGFPE.
- * Args are same as MachEmulateFP.
+ * Args are same as mips_emul_fp.
  */
 STATIC_LEAF(fpemul_sigill)
-#ifdef FPEMUL
-STATIC_XLEAF(bcemul_sigill)
-#endif
 	li	t0, 0xFFFFFF00
 	and	a2, a2, t0
@@ -5336,8 +4561,7 @@
 	REG_EPILOGUE
 
-	move	a2, a0				# code = instruction
-	move	a0, MIPS_CURLWP			# get current process
-	li	a1, SIGILL
-	j	_C_LABEL(fpemul_trapsignal)
+	move	a1, a0				# code = instruction
+	move	a0, MIPS_CURLWP			# get current lwp
+	j	_C_LABEL(mips_fpuillinst)
 END(fpemul_sigill)
 
@@ -5350,12 +4574,11 @@
 	REG_EPILOGUE
 
-	move	a2, a0				# code = instruction
-	move	a0, MIPS_CURLWP			# get current process
-	li	a1, SIGFPE
-	j	_C_LABEL(fpemul_trapsignal)
+	move	a1, a3				# fpustat
+	move	a0, MIPS_CURLWP			# get current lwp
+	j	_C_LABEL(mips_fpuexcept)
 END(fpemul_sigfpe)
 
 #ifdef FPEMUL
-STATIC_LEAF(bcemul_sigfpe)
+STATIC_LEAF(mips_emul_sigfpe)
 	li	t0, 0xFFFFFF00
 	and	a2, a2, t0
@@ -5365,8 +4588,7 @@
 	REG_EPILOGUE
 
-	move	a2, a0				# code = instruction
-	move	a0, MIPS_CURLWP			# get current process
-	li	a1, SIGFPE
-	j	_C_LABEL(fpemul_trapsignal)
-END(bcemul_sigfpe)
+	move	a1, a3				# fpustat
+	move	a0, MIPS_CURLWP			# get current lwp
+	j	_C_LABEL(mips_fpuexcept)
+END(mips_emul_sigfpe)
 #endif
Index: /trunk/src/sys/arch/mips/mips/genassym.cf
===================================================================
--- /trunk/src/sys/arch/mips/mips/genassym.cf	(revision 151)
+++ /trunk/src/sys/arch/mips/mips/genassym.cf	(revision 152)
@@ -1,3 +1,3 @@
-#	$NetBSD: genassym.cf,v 1.44.12.22 2010/05/16 00:40:51 matt Exp $
+#	genassym.cf,v 1.44.12.26 2011/04/29 08:26:25 matt Exp
 #
 # Copyright (c) 1992, 1993
@@ -82,5 +82,4 @@
 include <sys/proc.h>
 include <sys/mbuf.h>
-include <sys/user.h>
 include <sys/mutex.h>
 include <sys/cpu.h>
@@ -89,4 +88,5 @@
 
 include <machine/cpu.h>
+include <mips/pcb.h>
 include <mips/cache.h>
 include <mips/regnum.h>
@@ -95,9 +95,10 @@
 include <machine/locore.h>
 
+define	PAGE_SIZE		PAGE_SIZE
+
 ifdef __HAVE_FAST_SOFTINTS
 define	__HAVE_FAST_SOFTINTS	1
 endif
 
-define	PAGE_SIZE		PAGE_SIZE
 define	PAGE_SHIFT		PAGE_SHIFT
 define	MIPS_KSEG0_START	MIPS_KSEG0_START
@@ -112,12 +113,10 @@
 # Important offsets into the lwp and proc structs & associated constants
 define	L_CPU			offsetof(struct lwp, l_cpu)
-define	L_ADDR			offsetof(struct lwp, l_addr)
+define	L_CTXSWITCH		offsetof(struct lwp, l_ctxswtch)
+define	L_PCB			offsetof(struct lwp, l_addr)
 define	L_PRIORITY		offsetof(struct lwp, l_priority)
-define	L_WCHAN			offsetof(struct lwp, l_wchan)
+define	L_PRIVATE		offsetof(struct lwp, l_private)
+define	L_PROC			offsetof(struct lwp, l_proc)
 define	L_STAT			offsetof(struct lwp, l_stat)
-define	L_PROC			offsetof(struct lwp, l_proc)
-define	L_CTXSWITCH		offsetof(struct lwp, l_ctxswtch)
-
-# Process status constants
 define	L_MD_UTF		offsetof(struct lwp, l_md.md_utf)
 if defined(_KERNEL_OPT) && !defined(TSAR)
@@ -126,12 +125,13 @@
 endif
 define	L_MD_ASTPENDING		offsetof(struct lwp, l_md.md_astpending)
+define	L_WCHAN			offsetof(struct lwp, l_wchan)
 
 define	P_RASLIST		offsetof(struct proc, p_raslist)
 define	P_MD_SYSCALL		offsetof(struct proc, p_md.md_syscall)
 
-define	U_PCB_FPREGS		offsetof(struct user, u_pcb.pcb_fpregs)
-define	U_PCB_CONTEXT		offsetof(struct user, u_pcb.pcb_context)
-define	U_PCB_ONFAULT		offsetof(struct user, u_pcb.pcb_onfault)
-define	U_PCB_PPL		offsetof(struct user, u_pcb.pcb_ppl)
+define	PCB_FPREGS		offsetof(struct pcb, pcb_fpregs)
+define	PCB_CONTEXT		offsetof(struct pcb, pcb_context)
+define	PCB_ONFAULT		offsetof(struct pcb, pcb_onfault)
+define	PCB_PPL			offsetof(struct pcb, pcb_ppl)
 
 define	VM_MIN_ADDRESS		VM_MIN_ADDRESS
@@ -140,6 +140,4 @@
 define	VM_MAXUSER_ADDRESS	VM_MAXUSER_ADDRESS
 
-define	UVMEXP_SWTCH		offsetof(struct uvmexp, swtch)
-
 define	SIGFPE		 	SIGFPE
 define	SIGILL		 	SIGILL
@@ -148,6 +146,4 @@
 #				/* XXX */
 define	MIPSX_FLUSHICACHE	0
-define	MIPSX_CPU_SWITCH_RESUME	offsetof(struct locoresw, lsw_cpu_switch_resume)
-define	MIPSX_CPU_IDLE		offsetof(struct locoresw, lsw_cpu_idle)
 
 if defined(_KERNEL_OPT)
@@ -270,6 +266,4 @@
 define	FRAME_FP31		sizeof(mips_fpreg_t) * 31
 
-
-#define	KERNFRAME_SIZ	(sizeof(register_t) * (6 + 2 ) + sizeof(mips_reg_t) * (17 + 5))
 define	KERNFRAME_SIZ	sizeof(struct kernframe)
 if defined(__mips_o32) || defined(__mips_o64)
@@ -308,8 +302,9 @@
 define	CPU_INFO_CURLWP		offsetof(struct cpu_info, ci_curlwp)
 define	CPU_INFO_IDLELWP	offsetof(struct cpu_info, ci_data.cpu_idlelwp)
-ifndef NOFPU
-define	CPU_INFO_FPCURLWP	offsetof(struct cpu_info, ci_fpcurlwp)
-endif
-define	CPU_INFO_PMAP_SEGBASE	offsetof(struct cpu_info, ci_pmap_segbase)
+define	CPU_INFO_EV_TLBMISSES	offsetof(struct cpu_info, ci_ev_tlbmisses.ev_count)
+define	CPU_INFO_PMAP_SEG0TAB	offsetof(struct cpu_info, ci_pmap_seg0tab)
+ifdef _LP64
+define	CPU_INFO_PMAP_SEGTAB	offsetof(struct cpu_info, ci_pmap_segtab)
+endif
 define	CPU_INFO_DIVISOR_DELAY	offsetof(struct cpu_info, ci_divisor_delay)
 define	CPU_INFO_MTX_COUNT	offsetof(struct cpu_info, ci_mtx_count)
@@ -318,4 +313,5 @@
 define	CPU_INFO_KSP_TLB_SLOT	offsetof(struct cpu_info, ci_ksp_tlb_slot)
 endif
+define	CPU_INFO_TLB_INFO	offsetof(struct cpu_info, ci_tlb_info)
 
 define	IPL_NONE		IPL_NONE
@@ -340,4 +336,6 @@
 define	TLBMASK_LO1		offsetof(struct tlbmask, tlb_lo1)
 define	TLBMASK_MASK		offsetof(struct tlbmask, tlb_mask)
+define	TI_LOCK			offsetof(struct pmap_tlb_info, ti_lock)
+
 endif
 
@@ -347,6 +345,4 @@
 
 define	MCI_SDCACHE_SIZE	offsetof(struct mips_cache_info, mci_sdcache_size)
-
-define	SPLSW_SPLCHECK		offsetof(struct splsw, splsw_splcheck)
 
 if defined(TSAR)
@@ -356,2 +352,5 @@
 endif
 
+define	__SIMPLELOCK_LOCKED	__SIMPLELOCK_LOCKED
+define	_QUAD_LOWWORD		_QUAD_LOWWORD
+define	_QUAD_HIGHWORD		_QUAD_HIGHWORD
Index: /trunk/src/sys/arch/mips/mips/in_cksum.c
===================================================================
--- /trunk/src/sys/arch/mips/mips/in_cksum.c	(revision 151)
+++ /trunk/src/sys/arch/mips/mips/in_cksum.c	(revision 152)
@@ -1,3 +1,3 @@
-/* $NetBSD: in_cksum.c,v 1.13 2007/01/24 13:08:11 hubertf Exp $ */
+/* $NetBSD: in_cksum.c,v 1.13.66.1 2011/04/29 08:26:26 matt Exp $ */
 
 /*
@@ -43,5 +43,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: in_cksum.c,v 1.13 2007/01/24 13:08:11 hubertf Exp $");
+__KERNEL_RCSID(0, "$NetBSD: in_cksum.c,v 1.13.66.1 2011/04/29 08:26:26 matt Exp $");
 
 #include <sys/param.h>
@@ -57,9 +57,8 @@
 
 union memptr {
-	unsigned int *i;
-	unsigned long *l;
-	unsigned long u;
-	unsigned short *s;
-	unsigned char *c;
+	uint32_t *l;
+	uintptr_t u;
+	uint16_t *s;
+	uint8_t *c;
 };
 
@@ -84,8 +83,4 @@
 	/* Align to 32 bits. */
 	if (buf.u & 0x3) {
-		/* Skip to the end for very small mbufs */
-		if (n < 3)
-			goto verylittleleft;
-
 		/*
 	         * 16-bit-align.
@@ -108,4 +103,7 @@
 			odd_aligned = !odd_aligned;
 		}
+		/* Skip to the end for very small mbufs */
+		if (n <= 2)
+			goto postunaligned;
 
 		/* 32-bit-align */
@@ -199,5 +197,5 @@
  notmuchleft:
 	high = hilo = 0;
-	while (n >= 4) {
+	while (n >= sizeof(uint32_t)) {
 		w0 = *(buf.l++);
 		hilo += w0;
@@ -209,12 +207,13 @@
 	sum += high;
 
-	while (n > 1) {
-		n -= sizeof(*buf.s);
+ postunaligned:
+	/* handle post 32bit unaligned payloads */
+	if (n >= sizeof(uint16_t)) {
 		sum += *(buf.s++);
-	}
-
- verylittleleft:
-	/* handle trailing byte and short (possibly) unaligned payloads */
-	while (n-- > 0) {
+		n -= sizeof(uint16_t);
+	}
+
+	/* handle a trailing odd byte */
+	if (n > 0) {
 #if BYTE_ORDER == BIG_ENDIAN
 		sum += *(buf.c++) << 8;
@@ -222,4 +221,5 @@
 		sum += *(buf.c++);
 #endif
+		n = 0;
 	}
 
Index: /trunk/src/sys/arch/mips/mips/ipifuncs.c
===================================================================
--- /trunk/src/sys/arch/mips/mips/ipifuncs.c	(revision 151)
+++ /trunk/src/sys/arch/mips/mips/ipifuncs.c	(revision 152)
@@ -28,10 +28,12 @@
  */
 
+#include "opt_ddb.h"
+
 #include <sys/cdefs.h>
-
-__KERNEL_RCSID(0, "$NetBSD: ipifuncs.c,v 1.1.2.3 2010/03/24 19:23:46 cliff Exp $");
+__KERNEL_RCSID(0, "$NetBSD: ipifuncs.c,v 1.1.2.6 2011/04/29 08:26:26 matt Exp $");
 
 #include <sys/param.h>
 #include <sys/cpu.h>
+#include <sys/device.h>
 #include <sys/intr.h>
 
@@ -39,4 +41,10 @@
 
 #include <mips/cache.h>
+#include <mips/cpuset.h>
+#ifdef DDB
+#include <mips/db_machdep.h>
+#endif
+
+static void ipi_halt(void) __dead;
 
 static const char * const ipi_names[] = {
@@ -47,4 +55,6 @@
 	[IPI_SYNCICACHE]	= "ipi isync",
 	[IPI_KPREEMPT]	= "ipi kpreempt",
+	[IPI_SUSPEND]	= "ipi suspend",
+	[IPI_HALT]	= "ipi halt",
 };
 
@@ -86,8 +96,26 @@
 }
 
+#ifdef __HAVE_PREEEMPTION
 static inline void
 ipi_kpreempt(struct cpu_info *ci)
 {
 	softint_trigger(SOFTINT_KPREEMPT);
+}
+#endif
+
+/*
+ * Process cpu stop-self event.
+ * XXX could maybe add/use locoresw halt function?
+ */
+static void
+ipi_halt(void)
+{
+	const u_int my_cpu = cpu_number();
+	printf("cpu%u: shutting down\n", my_cpu);
+	CPUSET_ADD(cpus_halted, my_cpu);
+	splhigh();
+	for (;;)
+		;
+	/* NOTREACHED */
 }
 
@@ -106,21 +134,23 @@
 	}
 	if (ipi_mask & __BIT(IPI_SHOOTDOWN)) {
-		ci->ci_evcnt_per_ipi[IPI_NOP].ev_count++;
+		ci->ci_evcnt_per_ipi[IPI_SHOOTDOWN].ev_count++;
 		ipi_shootdown(ci);
 	}
 	if (ipi_mask & __BIT(IPI_FPSAVE)) {
-		ci->ci_evcnt_per_ipi[IPI_NOP].ev_count++;
+		ci->ci_evcnt_per_ipi[IPI_FPSAVE].ev_count++;
 		ipi_fpsave(ci);
 	}
 	if (ipi_mask & __BIT(IPI_SYNCICACHE)) {
-		ci->ci_evcnt_per_ipi[IPI_NOP].ev_count++;
+		ci->ci_evcnt_per_ipi[IPI_SYNCICACHE].ev_count++;
 		ipi_syncicache(ci);
 	}
-#ifdef IPI_HALT
+	if (ipi_mask & __BIT(IPI_SUSPEND)) {
+		ci->ci_evcnt_per_ipi[IPI_SUSPEND].ev_count++;
+		cpu_pause(NULL);
+	}
 	if (ipi_mask & __BIT(IPI_HALT)) {
-		ci->ci_evcnt_per_ipi[IPI_NOP].ev_count++;
+		ci->ci_evcnt_per_ipi[IPI_HALT].ev_count++;
 		ipi_halt();
 	}
-#endif
 }
 
Index: /trunk/src/sys/arch/mips/mips/kgdb_machdep.c
===================================================================
--- /trunk/src/sys/arch/mips/mips/kgdb_machdep.c	(revision 151)
+++ /trunk/src/sys/arch/mips/mips/kgdb_machdep.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: kgdb_machdep.c,v 1.12.16.1 2010/02/01 04:16:19 matt Exp $	*/
+/*	$NetBSD: kgdb_machdep.c,v 1.12.16.2 2011/04/29 08:26:26 matt Exp $	*/
 
 /*-
@@ -43,9 +43,4 @@
  *    notice, this list of conditions and the following disclaimer in the
  *    documentation and/or other materials provided with the distribution.
- * 3. All advertising materials mentioning features or use of this software
- *    must display the following acknowledgement:
- *	This product includes software developed by Matthias Pfaller.
- * 4. The name of the author may not be used to endorse or promote products
- *    derived from this software without specific prior written permission
  *
  * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
@@ -62,5 +57,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: kgdb_machdep.c,v 1.12.16.1 2010/02/01 04:16:19 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: kgdb_machdep.c,v 1.12.16.2 2011/04/29 08:26:26 matt Exp $");
 
 #include "opt_ddb.h"
@@ -82,5 +77,4 @@
 #include <sys/param.h>
 #include <sys/proc.h>
-#include <sys/user.h>
 #include <sys/reboot.h>
 #include <sys/kgdb.h>
@@ -129,7 +123,5 @@
  */
 int
-kgdb_acc(va, len)
-	vaddr_t va;
-	size_t len;
+kgdb_acc(vaddr_t va, size_t len)
 {
 	vaddr_t last_va;
@@ -152,6 +144,5 @@
  */
 int 
-kgdb_signal(type)
-	int type;
+kgdb_signal(int type)
 {
 	switch (type) {
@@ -195,7 +186,5 @@
  */
 void
-kgdb_getregs(regs, gdb_regs)
-	db_regs_t *regs;
-	kgdb_reg_t *gdb_regs;
+kgdb_getregs(db_regs_t *regs, kgdb_reg_t *gdb_regs)
 {
 	memset(gdb_regs, 0, KGDB_NUMREGS * sizeof(kgdb_reg_t));
@@ -241,7 +230,5 @@
  */
 void
-kgdb_setregs(regs, gdb_regs)
-	db_regs_t *regs;
-	kgdb_reg_t *gdb_regs;
+kgdb_setregs(db_regs_t *regs, kgdb_reg_t *gdb_regs)
 {
 	regs->r_regs[_R_PC] = gdb_regs[37];   /* PC */
@@ -253,6 +240,5 @@
  */
 void
-kgdb_connect(verbose)
-	int verbose;
+kgdb_connect(int verbose)
 {
 	if (kgdb_dev < 0)
@@ -277,5 +263,5 @@
 kgdb_panic(void)
 {
-	if (kgdb_dev >= 0 && kgdb_debug_panic) {
+	if (kgdb_dev != NODEV && kgdb_debug_panic) {
 		printf("entering kgdb\n");
 		kgdb_connect(kgdb_active == 0);
Index: /trunk/src/sys/arch/mips/mips/linux_trap.c
===================================================================
--- /trunk/src/sys/arch/mips/mips/linux_trap.c	(revision 151)
+++ /trunk/src/sys/arch/mips/mips/linux_trap.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: linux_trap.c,v 1.9 2008/04/28 20:23:28 martin Exp $ */
+/*	$NetBSD: linux_trap.c,v 1.9.18.1 2011/04/29 08:26:26 matt Exp $ */
 
 /*-
@@ -31,10 +31,9 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: linux_trap.c,v 1.9 2008/04/28 20:23:28 martin Exp $");
+__KERNEL_RCSID(0, "$NetBSD: linux_trap.c,v 1.9.18.1 2011/04/29 08:26:26 matt Exp $");
 
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/proc.h>
-#include <sys/user.h>
 #include <sys/acct.h>
 #include <sys/kernel.h>
